require 'rails_helper'
require 'devise/jwt/test_helpers'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.
#
# Also compared to earlier versions of this generator, there are no longer any
# expectations of assigns and templates rendered. These features have been
# removed from Rails core in Rails 5, but can be added back in via the
# `rails-controller-testing` gem.

RSpec.describe PhonesController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # Phone. As you add validations to Phone, be sure to
  # adjust the attributes here as well.

  before :all do
    @user = FactoryBot.create(:user)
    @phone = FactoryBot.build(:phone, user: @user)
  end

  let(:auth_headers) do
    headers = { 'Accept' => 'application/json', 'Content-Type' => 'application/json' }
    Devise::JWT::TestHelpers.auth_headers(headers, @user)
  end

  before :each do
    request.headers.merge! auth_headers
  end


  let(:valid_attributes) {
    @phone.attributes
  }

  let(:invalid_attributes) {
    FactoryBot.attributes_for(:phone_invalid)
  }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # PhonesController. Be sure to keep this updated too.
  let(:valid_session) { {} }

  describe "GET #index" do
    it "returns a success response" do
      phone = Phone.create! valid_attributes
      get :index, params: {}
      expect(response).to be_successful
    end
  end

  describe "GET #show" do
    it "returns a success response" do
      phone = Phone.create! valid_attributes
      get :show, params: {id: phone.to_param}
      expect(response).to be_successful
    end
  end

  describe "POST #create" do
    context "with valid params" do
      it "creates a new Phone" do
        expect {
          post :create, params: {phone: valid_attributes}
        }.to change(Phone, :count).by(1)
      end

      it "renders a JSON response with the new phone" do

        post :create, params: {phone: valid_attributes}
        expect(response).to have_http_status(:created)
        expect(response.content_type).to eq('application/json; charset=utf-8')
        expect(response.location).to eq(phone_url(Phone.last))
      end
    end

    context "with invalid params" do
      it "renders a JSON response with errors for the new phone" do

        post :create, params: {phone: invalid_attributes}
        expect(response).to have_http_status(:unprocessable_entity)
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end
  end

  describe "PUT #update" do
    context "with valid params" do
      before :all do
        @user.add_role :admin
        @phone = FactoryBot.build(:phone, user: @user)
      end

      let(:new_attributes) {
        @phone.attributes
      }

      it "updates the requested phone" do
        phone = Phone.create! valid_attributes
        put :update, params: {id: phone.to_param, phone: new_attributes}
        phone.reload
        expect(phone.imei).to match @phone.imei
      end

      it "renders a JSON response with the phone" do
        phone = Phone.create! valid_attributes

        put :update, params: {id: phone.to_param, phone: valid_attributes}
        expect(response).to have_http_status(:ok)
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end

    context "with invalid params" do
      it "renders a JSON response with errors for the phone" do
        phone = Phone.create! valid_attributes

        put :update, params: {id: phone.to_param, phone: invalid_attributes}
        expect(response).to have_http_status(:unprocessable_entity)
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end
  end

  describe "DELETE #destroy" do
    it "destroys the requested phone" do
      phone = Phone.create! valid_attributes
      expect {
        delete :destroy, params: {id: phone.to_param}
      }.to change(Phone, :count).by(-1)
    end
  end

end
